using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.OleDb;

namespace OleDB
{
	/// <summary>
	/// Summary description for DeletedForm.
	/// </summary>
	public class DeletedForm : SimpleForm
	{
		protected System.Windows.Forms.Button buttonFlagForDelete;
		protected System.Windows.Forms.Button buttonDeleteSelectedRow;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		//private System.ComponentModel.Container components = null;

		public DeletedForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.buttonFlagForDelete = new System.Windows.Forms.Button();
			this.buttonDeleteSelectedRow = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.dataSet)).BeginInit();
			this.SuspendLayout();
			// 
			// listBox1
			// 
			this.listBox1.Name = "listBox1";
			// 
			// buttonAddRow
			// 
			this.buttonAddRow.Name = "buttonAddRow";
			// 
			// buttonUpdateSelectedRow
			// 
			this.buttonUpdateSelectedRow.Name = "buttonUpdateSelectedRow";
			// 
			// buttonFill
			// 
			this.buttonFill.Name = "buttonFill";
			// 
			// buttonFlagForDelete
			// 
			this.buttonFlagForDelete.Location = new System.Drawing.Point(56, 96);
			this.buttonFlagForDelete.Name = "buttonFlagForDelete";
			this.buttonFlagForDelete.TabIndex = 6;
			this.buttonFlagForDelete.Text = "Flag Row";
			this.buttonFlagForDelete.Click += new System.EventHandler(this.buttonFlagForDelete_Click);
			// 
			// buttonDeleteSelectedRow
			// 
			this.buttonDeleteSelectedRow.Location = new System.Drawing.Point(56, 72);
			this.buttonDeleteSelectedRow.Name = "buttonDeleteSelectedRow";
			this.buttonDeleteSelectedRow.TabIndex = 5;
			this.buttonDeleteSelectedRow.Text = "Delete Row";
			this.buttonDeleteSelectedRow.Click += new System.EventHandler(this.buttonDeleteSelectedRow_Click);
			// 
			// DeletedForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(400, 266);
			this.Controls.Add(this.buttonFlagForDelete);
			this.Controls.Add(this.buttonDeleteSelectedRow);
			this.Name = "DeletedForm";
			this.Text = "DeletedForm";
			this.Load += new System.EventHandler(this.DeletedForm_Load);
			this.Controls.SetChildIndex(this.buttonDeleteSelectedRow, 0);
			this.Controls.SetChildIndex(this.buttonFlagForDelete, 0);
			this.Controls.SetChildIndex(this.listBox1, 0);
			this.Controls.SetChildIndex(this.buttonAddRow, 0);
			this.Controls.SetChildIndex(this.buttonUpdateSelectedRow, 0);
			this.Controls.SetChildIndex(this.buttonFill, 0);
			((System.ComponentModel.ISupportInitialize)(this.dataSet)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void buttonDeleteSelectedRow_Click(object sender, System.EventArgs e)
		{
			int index = listBox1.SelectedIndex;
			if (index == -1) return;

			DataRow row = dataSet.Tables[0].Rows[index];

			dataSet.Tables[0].Rows.Remove(row);

			PopulateListBox();
		}

		private void buttonFlagForDelete_Click(object sender, System.EventArgs e)
		{
			int index = listBox1.SelectedIndex;
			if (index == -1) return;

			DataRow row = dataSet.Tables[0].Rows[index];

			row.Delete();

			PopulateListBox();
		}

		protected override void PopulateListBox() 
		{
			listBox1.Items.Clear();

			foreach( DataRow row in dataSet.Tables[0].Rows ) 
			{
				if ((row.RowState & DataRowState.Deleted) 
					!= DataRowState.Deleted) 
				{
					string item = row["ContactTitle"] + ", " + row["Contactname"];
					listBox1.Items.Add(item);
				}
			}
		}

		private void DeletedForm_Load(object sender, System.EventArgs e)
		{
			buttonDeleteSelectedRow.Enabled = false;
			buttonFlagForDelete.Enabled = false;
		}

		protected override void buttonFill_Click(object sender, System.EventArgs e)
		{
			base.buttonFill_Click(sender, e);

			buttonDeleteSelectedRow.Enabled = true;
			buttonFlagForDelete.Enabled = true;

		}

	}
}
