using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace OleDB
{
	/// <summary>
	/// Summary description for DeletedShow.
	/// </summary>
	public class DeletedShow : DeletedForm
	{
		protected System.Windows.Forms.Button buttonShowChanges;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		//private System.ComponentModel.Container components = null;

		public DeletedShow()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.buttonShowChanges = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.dataSet)).BeginInit();
			this.SuspendLayout();
			// 
			// buttonFlagForDelete
			// 
			this.buttonFlagForDelete.Name = "buttonFlagForDelete";
			// 
			// buttonDeleteSelectedRow
			// 
			this.buttonDeleteSelectedRow.Name = "buttonDeleteSelectedRow";
			// 
			// listBox1
			// 
			this.listBox1.Items.AddRange(new object[] {
														  ""});
			this.listBox1.Name = "listBox1";
			// 
			// buttonAddRow
			// 
			this.buttonAddRow.Name = "buttonAddRow";
			// 
			// buttonUpdateSelectedRow
			// 
			this.buttonUpdateSelectedRow.Name = "buttonUpdateSelectedRow";
			// 
			// buttonFill
			// 
			this.buttonFill.Name = "buttonFill";
			// 
			// buttonShowChanges
			// 
			this.buttonShowChanges.Location = new System.Drawing.Point(56, 120);
			this.buttonShowChanges.Name = "buttonShowChanges";
			this.buttonShowChanges.Size = new System.Drawing.Size(104, 32);
			this.buttonShowChanges.TabIndex = 7;
			this.buttonShowChanges.Text = "Show Changes";
			this.buttonShowChanges.Click += new System.EventHandler(this.buttonShowChanges_Click);
			// 
			// DeletedShow
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(464, 494);
			this.Controls.Add(this.buttonShowChanges);
			this.Name = "DeletedShow";
			this.Text = "DeletedShow";
			this.Controls.SetChildIndex(this.buttonFill, 0);
			this.Controls.SetChildIndex(this.buttonShowChanges, 0);
			this.Controls.SetChildIndex(this.listBox1, 0);
			this.Controls.SetChildIndex(this.buttonAddRow, 0);
			this.Controls.SetChildIndex(this.buttonUpdateSelectedRow, 0);
			this.Controls.SetChildIndex(this.buttonDeleteSelectedRow, 0);
			this.Controls.SetChildIndex(this.buttonFlagForDelete, 0);
			((System.ComponentModel.ISupportInitialize)(this.dataSet)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		protected override void PopulateListBox() 
		{
			listBox1.Items.Clear();

			foreach( DataRow row in dataSet.Tables[0].Rows ) 
			{
				if ((row.RowState & DataRowState.Deleted) 
					!= DataRowState.Deleted) 
				{
					string item = row["ContactTitle"] + ", " + row["Contactname"];
					listBox1.Items.Add(item);
				} 
				else 
				{
					string id = row["CustomerID", DataRowVersion.Original].ToString();
					listBox1.Items.Add("***deleted***: " + id);
				}
			}
		}

		private void buttonShowChanges_Click(object sender, System.EventArgs e)
		{
			listBox1.Items.Clear();
			ShowChanges(DataRowState.Modified);
			ShowChanges(DataRowState.Added);
			ShowChanges(DataRowState.Deleted);
		}

		private void ShowChanges(DataRowState state) 
		{
			DataTable tableChanges = 
				dataSet.Tables[0].GetChanges(state);
			if (tableChanges != null) 
			{
				foreach (DataRow row in tableChanges.Rows) 
				{
					DataRowVersion version = DataRowVersion.Current;
					if ((row.RowState & DataRowState.Deleted) 
						== DataRowState.Deleted) 
					{
						version = DataRowVersion.Original;
					} 
					string id = row["CustomerID", version].ToString();
					listBox1.Items.Add(id + "::" + state.ToString());
				}
			}
		}
	}
}
