using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace OleDB
{
	/// <summary>
	/// Summary description for Expression.
	/// </summary>
	public class Expression : Relation
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		//private System.ComponentModel.Container components = null;

		public Expression()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//



		}

		protected override void buttonFill_Click(object sender, System.EventArgs e)
		{

			base.buttonFill_Click(sender, e);

			DataColumn exp = new DataColumn();
			exp.ColumnName = "ContactTitleName";
			exp.DataType = typeof(string);
			exp.Expression = "ContactTitle + ', ' + ContactName";

			dataSet.Tables["Customers"].Columns.Add(exp);

			DataColumn exp2 = new DataColumn();
			exp2.ColumnName = "CustomerContactName";
			exp2.DataType = typeof(string);
			exp2.Expression = "parent(CustomersOrders).ContactName";

			dataSet.Tables["Orders"].Columns.Add(exp2);

			PopulateListBox();

		}


		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			((System.ComponentModel.ISupportInitialize)(this.dataSet)).BeginInit();
			this.SuspendLayout();
			// 
			// listBox2
			// 
			this.listBox2.Name = "listBox2";
			// 
			// buttonShowChanges
			// 
			this.buttonShowChanges.Name = "buttonShowChanges";
			// 
			// buttonFlagForDelete
			// 
			this.buttonFlagForDelete.Name = "buttonFlagForDelete";
			// 
			// buttonDeleteSelectedRow
			// 
			this.buttonDeleteSelectedRow.Name = "buttonDeleteSelectedRow";
			// 
			// listBox1
			// 
			this.listBox1.Name = "listBox1";
			// 
			// buttonAddRow
			// 
			this.buttonAddRow.Name = "buttonAddRow";
			// 
			// buttonUpdateSelectedRow
			// 
			this.buttonUpdateSelectedRow.Name = "buttonUpdateSelectedRow";
			// 
			// Expression
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(440, 510);
			this.Name = "Expression";
			this.Text = "Expression";
			((System.ComponentModel.ISupportInitialize)(this.dataSet)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		protected override string GetListRow(DataRow row)
		{
			return row["ContactTitleName"].ToString();
		}

		protected override string GetChildListRow(DataRow row) 
		{
			string item = "";
			if( (row.RowState & DataRowState.Deleted) != 0 )  
			{
				string id =
					row["OrderID", DataRowVersion.Original].ToString();
				item = "***deleted***: " + id;
			} 
			else 
			{
				item = row["OrderID"] + ", " + row["OrderDate"] + ", " + row["CustomerContactName"];
				if( row.HasErrors ) item += "(***" + row.RowError + "***)";
			}
			return item;
		}

		protected override void PopulateListBox() 
		{
			if (dataSet.Tables.Count < 2) return;

			if (!dataSet.Tables["Orders"].Columns.Contains("CustomerContactName")) return;
			
			base.PopulateListBox();

		}

	}
}
