using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Data.OleDb;

namespace OleDBTyped
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class SimpleForm : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		protected System.ComponentModel.Container components = null;

		public SimpleForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//


		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.listBox1 = new System.Windows.Forms.ListBox();
			this.buttonAddRow = new System.Windows.Forms.Button();
			this.buttonUpdateSelectedRow = new System.Windows.Forms.Button();
			this.buttonFill = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// listBox1
			// 
			this.listBox1.Location = new System.Drawing.Point(184, 0);
			this.listBox1.Name = "listBox1";
			this.listBox1.Size = new System.Drawing.Size(248, 264);
			this.listBox1.TabIndex = 0;
			// 
			// buttonAddRow
			// 
			this.buttonAddRow.Location = new System.Drawing.Point(56, 24);
			this.buttonAddRow.Name = "buttonAddRow";
			this.buttonAddRow.TabIndex = 1;
			this.buttonAddRow.Text = "Add Row";
			this.buttonAddRow.Click += new System.EventHandler(this.buttonAddRow_Click);
			// 
			// buttonUpdateSelectedRow
			// 
			this.buttonUpdateSelectedRow.Location = new System.Drawing.Point(56, 48);
			this.buttonUpdateSelectedRow.Name = "buttonUpdateSelectedRow";
			this.buttonUpdateSelectedRow.TabIndex = 2;
			this.buttonUpdateSelectedRow.Text = "Update Row";
			this.buttonUpdateSelectedRow.Click += new System.EventHandler(this.buttonUpdateSelectedRow_Click);
			// 
			// buttonFill
			// 
			this.buttonFill.Location = new System.Drawing.Point(56, 0);
			this.buttonFill.Name = "buttonFill";
			this.buttonFill.TabIndex = 3;
			this.buttonFill.Text = "Fill";
			this.buttonFill.Click += new System.EventHandler(this.buttonFill_Click);
			// 
			// SimpleForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(464, 558);
			this.Controls.Add(this.buttonFill);
			this.Controls.Add(this.buttonUpdateSelectedRow);
			this.Controls.Add(this.buttonAddRow);
			this.Controls.Add(this.listBox1);
			this.Name = "SimpleForm";
			this.Text = "Simple Access";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Chapter12Form());
		}

		protected System.Windows.Forms.ListBox listBox1;
		protected System.Windows.Forms.Button buttonAddRow;
		protected OleDBTyped.Dataset1 customerSet1 = new Dataset1();
		protected System.Windows.Forms.Button buttonUpdateSelectedRow;
		protected System.Windows.Forms.Button buttonFill;

		protected DataSet dataSet = new DataSet();
		private void Form1_Load(object sender, System.EventArgs e)
		{
			buttonAddRow.Enabled = false;
			buttonUpdateSelectedRow.Enabled = false;
		}

		protected virtual void PopulateListBox() 
		{
			listBox1.Items.Clear();

			foreach( Dataset1.CustomersRow row in customerSet1.Customers.Rows ) 
			{
				listBox1.Items.Add(GetListRow(row));
			}
		}

		protected virtual string GetListRow(Dataset1.CustomersRow row) 
		{
			return row.ContactTitle + ", " + row.ContactName;			
		}

		private void buttonAddRow_Click(object sender, System.EventArgs e)
		{
			((Button) sender).Enabled = false;
			Dataset1.CustomersRow row = customerSet1.Customers.NewCustomersRow();
			row.CustomerID = "DOWNEYT";
			row.ContactTitle = "Instructor";
			row.ContactName = "Tim Downey";
			row.CompanyName = "FIU";
			row.City = "Miami";
			row.Country = "USA";
			row.Fax = "";
			row.Region = "FL";
			row.PostalCode = "33199";
			row.Address = "Univeristy Park";
			row.Phone = "73329";
			customerSet1.Customers.AddCustomersRow(row);

			PopulateListBox();


		}

		private void buttonUpdateSelectedRow_Click(object sender, System.EventArgs e)
		{
			int index = listBox1.SelectedIndex;
			if (index == -1) return;

			Dataset1.CustomersRow row = customerSet1.Customers[index];
			row.ContactTitle = "CEO";

			PopulateListBox();
		}

		protected bool m_CustomersFilled = false;
		protected virtual void buttonFill_Click(object sender, System.EventArgs e)
		{
			if (!m_CustomersFilled) 
			{
				m_CustomersFilled = true;
				OleDbConnection conn = new OleDbConnection();
				string strLocationDB = Directory.GetCurrentDirectory() + @"\..\..\northwind.mdb";
				conn.ConnectionString = @"Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Registry Path=;Jet OLEDB:Database Locking Mode=1;Jet OLEDB:Database Password=;Data Source=""" +
					strLocationDB + @""";Password=;Jet OLEDB:Engine Type=5;Jet OLEDB:Global Bulk Transactions=1;Provider=""Microsoft.Jet.OLEDB.4.0"";Jet OLEDB:System database=;Jet OLEDB:SFP=False;Extended Properties=;Mode=Share Deny None;Jet OLEDB:New Database Password=;Jet OLEDB:Create System Database=False;Jet OLEDB:Don't Copy Locale on Compact=False;Jet OLEDB:Compact Without Replica Repair=False;User ID=Admin;Jet OLEDB:Encrypt Database=False";

				OleDbDataAdapter adapter = new OleDbDataAdapter(conn.CreateCommand());
				adapter.SelectCommand.CommandText = "select * from customers";

				adapter.Fill(customerSet1, "Customers");

				PopulateListBox();

				buttonAddRow.Enabled = true;
				buttonUpdateSelectedRow.Enabled = true;
			}

		}

	}
}
