using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using System.Data;

namespace ScratchDB
{
	public class Relation : ScratchDB.MultiTable
	{
		//private System.ComponentModel.IContainer components = null;

		public Relation()
		{
			// This call is required by the Windows Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call

			DataTable customers = dataSet.Tables["Customers"];
			DataTable orders = dataSet.Tables["Orders"];

			DataRelation relation = new DataRelation(
				"CustomersOrders",
				customers.Columns["CustomerID"],
				orders.Columns["CustomerID"]);

			dataSet.Relations.Add(relation);

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			((System.ComponentModel.ISupportInitialize)(this.dataSet)).BeginInit();
			this.SuspendLayout();
			// 
			// buttonShowChanges
			// 
			this.buttonShowChanges.Name = "buttonShowChanges";
			// 
			// buttonFlagForDelete
			// 
			this.buttonFlagForDelete.Name = "buttonFlagForDelete";
			// 
			// buttonDeleteSelectedRow
			// 
			this.buttonDeleteSelectedRow.Name = "buttonDeleteSelectedRow";
			// 
			// listBox1
			// 
			this.listBox1.Name = "listBox1";
			this.listBox1.SelectedIndexChanged += new System.EventHandler(this.listBox1_SelectedIndexChanged);
			// 
			// buttonAddRow
			// 
			this.buttonAddRow.Name = "buttonAddRow";
			// 
			// buttonUpdateSelectedRow
			// 
			this.buttonUpdateSelectedRow.Name = "buttonUpdateSelectedRow";
			// 
			// Relation
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(456, 486);
			this.Name = "Relation";
			this.Load += new System.EventHandler(this.Relation_Load);
			((System.ComponentModel.ISupportInitialize)(this.dataSet)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void Relation_Load(object sender, System.EventArgs e)
		{
		}

		protected override void PopulateListBox() 
		{
			if (dataSet.Tables.Count < 2) return;

			base.PopulateListBox();

			PopulateChildListBox();
		}

		void PopulateChildListBox() 
		{
			// Clear the listbox
			listBox2.Items.Clear();

			// Get the currently selected parent custom row
			int index = listBox1.SelectedIndex;
			if( index == -1 ) return;

			// Get row from data set
			DataRow parent = dataSet.Tables["Customers"].Rows[index];

			// Enumerate child rows
			foreach( DataRow row in parent.GetChildRows("CustomersOrders") ) 
			{
				listBox2.Items.Add(GetChildListRow(row));
			}
		}

		private void listBox1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			PopulateChildListBox();
		}

		protected override string GetChildListRow(DataRow row) 
		{
			string item = "";
			if( (row.RowState & DataRowState.Deleted) != 0 )  
			{
				string id =
					row["OrderID", DataRowVersion.Original].ToString();
				item = "***deleted***: " + id;
			} 
			else 
			{
				item = row["OrderID"] + ", " + row["OrderDate"];
				if( row.HasErrors ) item += "(***" + row.RowError + "***)";
			}
			return item;
		}
	}
}

